unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ExtCtrls, CLbmp, StdCtrls, ComCtrls ;

type
  TFrmPrincipal = class(TForm)
    MainMenu: TMainMenu;
    Fichier: TMenuItem;
    Quitter: TMenuItem;
    Options: TMenuItem;
    Proprietes: TMenuItem;
    N2: TMenuItem;
    Ouvrir: TMenuItem;
    OpenDialog: TOpenDialog;
    Renverser1: TMenuItem;
    Horizontal: TMenuItem;
    Vertical: TMenuItem;
    Couleurs1: TMenuItem;
    Negatif: TMenuItem;
    Griser: TMenuItem;
    Afficherlapalette: TMenuItem;
    AjusterRVB: TMenuItem;
    Palette: TMenuItem;
    Enregistrer: TMenuItem;
    Charger: TMenuItem;
    Traitements: TMenuItem;
    OpenDiaPal: TOpenDialog;
    SaveDiaPal: TSaveDialog;
    Sauvegarder: TMenuItem;
    Sauvegardersous: TMenuItem;
    N1: TMenuItem;
    N3: TMenuItem;
    SaveBitmapDiag: TSaveDialog;
    Conversion1: TMenuItem;
    N24bitsparPixel1: TMenuItem;
    N32bitsparPixel1: TMenuItem;
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure QuitterClick(Sender: TObject);
    procedure OuvrirClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure HorizontalClick(Sender: TObject);
    procedure VerticalClick(Sender: TObject);
    procedure AjusterRVBClick(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure AfficherlapaletteClick(Sender: TObject);
    procedure ProprietesClick(Sender: TObject);
    procedure NegatifClick(Sender: TObject);
    procedure GriserClick(Sender: TObject);
    procedure ChargerClick(Sender: TObject);
    procedure EnregistrerClick(Sender: TObject);
    procedure SauvegarderClick(Sender: TObject);
    procedure SauvegardersousClick(Sender: TObject);
    procedure N24bitsparPixel1Click(Sender: TObject);
    procedure N32bitsparPixel1Click(Sender: TObject);
  public
    FichierCharger :Boolean;         {Indicateur pour fichier charger ou pas}
    BmpFichier     :TFichierBitmap;  {Instance de la class TFichierBitmap}
    CheminFichier  :String;          {Chemin du fichier}
    Function CalculEspace( Octets :Integer ) :String;
  end;

Var
  FrmPrincipal     :TFrmPrincipal; {Fentre principale}

Implementation
    Uses Unit2, Unit3, Unit4, Unit5; {Utilisation de la fentre
                                      FrmPalette / FrmInfo / FrmAjuster...}
{$R *.DFM}


procedure TFrmPrincipal.FormActivate(Sender: TObject);
{Objectif :Crer un instance sur la class TFichierBitmap.}
begin
     BmpFichier := TFichierBitmap.Creer;
end;

procedure TFrmPrincipal.FormClose(Sender: TObject; var Action: TCloseAction);
{Objectif :Librer la mmoire prise par le Bitmap.
           Avertir que le ficheir n'est plus charger.}
begin
     If FichierCharger Then
        BmpFichier.Detruire;

     FichierCharger := False;
end;


procedure TFrmPrincipal.QuitterClick(Sender: TObject);
{Objectif :Fermer l'application}
begin
     Close;
end;

procedure TFrmPrincipal.OuvrirClick(Sender: TObject);
{Objectif :Ouvrir un fichier en se servant de la boite de dialogue et ensuite
           crer le bitmap en se servant de l'instance BmpFichier.}
begin
     If OpenDialog.Execute Then
        If OpenDialog.FileName <> '' Then
        Begin
             FichierCharger := False;
             CheminFichier := OpenDialog.FileName;
             BmpFichier.Charger(CheminFichier);
             FichierCharger := BmpFichier.BitmapCharger;
             Repaint;

             {Si le chargement s'est bien droul alors...}
             If FichierCharger Then
             Begin
                  FrmPrincipal.Invalidate;
                  Caption := CheminFichier;
             End
             Else
                 Caption := 'Bitmap';
        End;
end;

procedure TFrmPrincipal.FormResize(Sender: TObject);
{Objectif :Rendre la planche a dessin (TImage) de la mme dimension que la
           fentre en cas de redimensionnement et redessiner le Bitmap.}
begin
     FrmPrincipal.Repaint;
end;

procedure TFrmPrincipal.HorizontalClick(Sender: TObject);
{Objectif :Se servir de la procdure FlipGaucheDroite appartenant  la
           class TFichierBitmap et ensuite dessiner le rsultat surl a planche
            dessin (TImage).}
begin
     If FichierCharger Then
     Begin
          BmpFichier.FlipGaucheDroite;
          FrmPrincipal.Repaint;
     End
     Else
         MessageBox( 0, PChar( 'Aucun Bitmap charg !'), PChar('Erreur'),
         MB_ICONSTOP + MB_OK );
end;

procedure TFrmPrincipal.NegatifClick(Sender: TObject);
{Objectif :Se servir de la procdure Ngatif appartenant  la
           class TFichierBitmap et ensuite dessiner le rsultat surl a planche
            dessin (TImage).}
begin
     If FichierCharger Then
     Begin
          BmpFichier.Negatif;
          FrmPrincipal.Repaint;
     End
     Else
         MessageBox( 0, PChar( 'Aucun Bitmap charg !'), PChar('Erreur'),
         MB_ICONSTOP + MB_OK );
end;

procedure TFrmPrincipal.VerticalClick(Sender: TObject);
{Objectif :Se servir de la procdure FlipHautBas appartenant  la
           class TFichierBitmap et ensuite dessiner le rsultat surl a planche
            dessin (TImage).}
begin
     If FichierCharger Then
     Begin
          BmpFichier.FlipHautBas;
          FrmPrincipal.Repaint;
     End
     Else
         MessageBox( 0, PChar( 'Aucun Bitmap charg !'), PChar('Erreur'),
         MB_ICONSTOP + MB_OK );

end;

procedure TFrmPrincipal.AjusterRVBClick(Sender: TObject);
{Objectif :Afficher la fentre FrmAjuste qui permet de faire des
           modifications sur les couleurs de l'image.
            la fermeture de celle-ci, vrifier si il faut appliquer les
           modifications. Ensuite rafficher le Bitmap.}
begin
     If FichierCharger Then
     Begin
          FrmAjuste.ShowModal;

          If FrmAjuste.ModalResult = mrOK Then
             BmpFichier.AjusterRGB( FrmAjuste.R,
                                    FrmAjuste.V,
                                    FrmAjuste.B );

             FrmPrincipal.Repaint;
     End
     Else
         MessageBox( 0, PChar( 'Aucun Bitmap charg !'), PChar('Erreur'),
         MB_ICONSTOP + MB_OK );

end;

procedure TFrmPrincipal.FormPaint(Sender: TObject);
{Objectif :Repaindre le composant si les dimension change ou si appel}
begin
     If FichierCharger Then
        BmpFichier.DessinerSur( FrmPrincipal.Canvas.Handle,
                                FrmPrincipal.ClientWidth,
                                FrmPrincipal.ClientHeight )
end;

procedure TFrmPrincipal.AfficherlapaletteClick(Sender: TObject);
{Objectif :Dessiner la palette sur la fentre FrmPalette.}
begin
     If FichierCharger Then
     Begin
          If (BmpFichier.NbBitsParPixel <= 8 ) Then
             FrmPalette.ShowModal
          Else
              MessageBox( 0, PChar( 'Ce bitmap ne possde pas de palette.' ),
                          'Erreur !', MB_OK Or MB_ICONSTOP );
     End
     Else
         MessageBox( 0, PChar( 'Aucun Bitmap charg !'), PChar('Erreur'),
         MB_ICONSTOP + MB_OK );

end;

Function TFrmPrincipal.CalculEspace( Octets :Integer ) :String;
{Objectif :On reoit en octet la dimension d'un fichier par exemple et l'on veut
           spcifier sa dimension avec la bonne mesure Ex :Mo, Ko, Octets}
Begin
     If Octets <= 1024 Then
        Result := IntToStr(Octets) + ' Octets'
     Else
         If (Octets >= 1024) And (Octets <= 1048576) Then
            Result := FloatToStrF( Octets / 1024, ffNumber, 3, 1 ) + ' Ko'
         Else
             Result := FloatToStrF( ((Octets / 1024) / 1024 ) , ffNumber, 3, 1 ) + ' Mo';
End;


procedure TFrmPrincipal.ProprietesClick(Sender: TObject);
{Objectif :Rcuprer les proprits du Bitmap et les afficher sur la fentre
           FrmInfo.}
begin
     If (FichierCharger) Then
     With FrmInfo Do
     Begin
          lbChemin.Caption      := 'Chemin  : ' + CheminFichier;
          lbLargeur.Caption     := 'Largeur : ' + IntToStr(BmpFichier.Largeur) + ' px';
          lbHauteur.Caption     := 'Hauteur : ' + IntToStr(BmpFichier.Hauteur) + ' px';
          lbNbBpp.Caption       := 'Bits par Pixels : ' + IntToStr(BmpFichier.NbBitsParPixel) + ' Bits';
          If BmpFichier.NbBitsParPixel <= 8 Then
             LbColorPal.Caption := 'Nombre de couleur dans la palette : ' + IntToStr(BmpFichier.PalNbCouleurs) + ' Couleurs '
          Else
              LbColorPal.Caption := 'Nombre de couleur dans la palette :Aucune palette';

          lbImageDim.Caption := 'Dimension de l''image en octets   :' + CalculEspace(BmpFichier.DimTableauPixels);
          lbDimPal.Caption   := 'Dimension de la palette en octets :' + CalculEspace(BmpFichier.PalNbCouleurs * SizeOf(TRGBQUAD) );

          ShowModal;
     End
     Else
         MessageBox( 0, PChar( 'Aucun Bitmap charg !'), PChar('Erreur'),
         MB_ICONSTOP + MB_OK );
end;


procedure TFrmPrincipal.GriserClick(Sender: TObject);
{Objectif :Afficher la fentre FrmGriser qui permet d'effectuer un ton
           de gris sur l'image.
            la fermeture de celle-ci, vrifier si il faut appliquer les
           modifications. Ensuite rafficher le Bitmap.}
begin
     If FichierCharger Then
     Begin
          FrmGriser.ShowModal;

          If FrmGriser.ModalResult = mrOK Then
             BmpFichier.Griser( FrmGriser.G );

          FrmPrincipal.Repaint;
     End
     Else
         MessageBox( 0, PChar( 'Aucun Bitmap charg !'), PChar('Erreur'),
         MB_ICONSTOP + MB_OK );
end;

procedure TFrmPrincipal.ChargerClick(Sender: TObject);
{Objectif :Offrir  l'utilisateur de pourvoir charger une palette}
begin
     If FichierCharger Then
     Begin
          If BmpFichier.NbBitsParPixel <= 8 Then
          Begin
               If OpenDiaPal.Execute Then
                  If OpenDiaPal.FileName <> '' Then
                  Begin
                       BmpFichier.ChargerPalette( OpenDiaPal.Filename );
                       FrmPrincipal.Repaint;
                  End;
               End
          Else
              MessageBox( 0, PChar( 'Ce bitmap ne peut reevoir de palette.' ),
                          'Erreur !', MB_OK Or MB_ICONSTOP );
     End
     Else
         MessageBox( 0, PChar( 'Aucun Bitmap charg !'), PChar('Erreur'),
         MB_ICONSTOP + MB_OK );
end;

procedure TFrmPrincipal.EnregistrerClick(Sender: TObject);
{Objectif :Possibilit d'enregistr la palette du bitmap}
begin
     If FichierCharger Then
     Begin
          If BmpFichier.NbBitsParPixel <= 8 Then
          Begin
               If SaveDiaPal.Execute Then
                  If SaveDiaPal.FileName <> '' Then
                  Begin
                       BmpFichier.EnregistrerPalette( SaveDiaPal.Filename );
                       FrmPrincipal.Repaint;
                  End;
          End
          Else
              MessageBox( 0, PChar( 'Ce bitmap ne possde pas de palette.' ),
                         'Erreur !', MB_OK Or MB_ICONSTOP );
     End
     Else
         MessageBox( 0, PChar( 'Aucun Bitmap charg !'), PChar('Erreur'),
         MB_ICONSTOP + MB_OK );
end;

procedure TFrmPrincipal.SauvegarderClick(Sender: TObject);
{Objectif :Sauvegarder le bitmap sous le nom courant}
begin
     If FichierCharger Then
     Begin
          If CheminFichier <> '' Then
             BmpFichier.EnregistrerBitmap( CheminFichier );
     End
     Else
         MessageBox( 0, PChar( 'Aucun Bitmap charg !'), PChar('Erreur'),
         MB_ICONSTOP + MB_OK );
end;

procedure TFrmPrincipal.SauvegardersousClick(Sender: TObject);
{Objectif :Sauvegarder le bitmap sous le nom courant}
begin
     If FichierCharger Then
     Begin
          If SaveBitmapDiag.Execute Then
             If SaveBitmapDiag.FileName <> '' Then
             Begin
                  BmpFichier.EnregistrerBitmap( SaveBitmapDiag.FileName );
                  CheminFichier := SaveBitmapDiag.FileName;
             End;
     End
     Else
         MessageBox( 0, PChar( 'Aucun Bitmap charg !'), PChar('Erreur'),
         MB_ICONSTOP + MB_OK );
end;

procedure TFrmPrincipal.N24bitsparPixel1Click(Sender: TObject);
{Objectif :Convertir l'image en 24 bits par Pixel}
begin
     If FichierCharger Then
     Begin
          BmpFichier.ConvertirEn24bpp;
          Repaint;
     End
     Else
         MessageBox( 0, PChar( 'Aucun Bitmap charg !'), PChar('Erreur'),
         MB_ICONSTOP + MB_OK );
end;

procedure TFrmPrincipal.N32bitsparPixel1Click(Sender: TObject);
{Objectif :Convertir l'image en 32 bits par Pixel}
begin
     If FichierCharger Then
     Begin
          BmpFichier.ConvertirEn32bpp( 255 );
          Repaint;
     End
     Else
         MessageBox( 0, PChar( 'Aucun Bitmap charg !'), PChar('Erreur'),
         MB_ICONSTOP + MB_OK );
end;

end.
