unit Unit4;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, CLbmp, Buttons;

type
  TFrmAjuste = class(TForm)
    GrBxImage: TGroupBox;
    GrBxRGB: TGroupBox;
    ImgPreview: TImage;
    UpDownR: TUpDown;
    UpDownV: TUpDown;
    UpDownB: TUpDown;
    lbRouge: TLabel;
    lbVert: TLabel;
    lbBleu: TLabel;
    btVoir: TButton;
    BitBtnAnnuler: TBitBtn;
    BitBtnOk: TBitBtn;
    procedure btVoirClick(Sender: TObject);
    procedure BitBtnOkClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure UpDownRClick(Sender: TObject; Button: TUDBtnType);
  public
    { Pourcentage rajout aux couleurs }
     R, V, B          :Byte;
  end;

var
  FrmAjuste        :TFrmAjuste;
  BitmapTemporaire :TFichierBitmap;

implementation
 Uses Unit1;
{$R *.DFM}

procedure TFrmAjuste.FormActivate(Sender: TObject);
{Objectif : l'activation de cette fentre, crer un bitmap temporaire pour
          les modifications et l'afficher comme preview.
          Rnitialisation  0 des TUpDown.}
begin
     R := 0;
     V := 0;
     B := 0;

     BitmapTemporaire := TFichierBitmap.Creer;
     BitMapTemporaire.CopyBitmapClass( FrmPrincipal.BmpFichier );

     If Not BitmapTemporaire.DessinerSur( ImgPreview.Canvas.Handle,
                                          ImgPreview.Width,
                                          ImgPreview.Height ) Then
        MessageBox( 0, 'Erreur  l''affichage du Bitmap comme preview.',
                    'Erreur d''Affichage', MB_OK );
     ImgPreview.Invalidate;

     UpDownR.Position := 0;
     UpDownV.Position := 0;
     UpDownB.Position := 0;
end;

procedure TFrmAjuste.btVoirClick(Sender: TObject);
{Objectif :Dessiner l'image selon le choix de l'utilisateur.}
begin
     BitmapTemporaire.AjusterRGB( UpDownR.Position,
                                  UpDownV.Position,
                                  UpDownB.Position );

     If Not BitmapTemporaire.DessinerSur( ImgPreview.Canvas.Handle,
                                          ImgPreview.Width,
                                          ImgPreview.Height ) Then
        MessageBox( 0, 'Erreur  l''affichage du Bitmap en preview.',
                    'Erreur d''Affichage', MB_OK );

     R := R + UpDownR.Position;
     V := V + UpDownV.Position;
     B := B + UpDownB.Position;

     UpDownR.Position := 0;
     UpDownV.Position := 0;
     UpDownB.Position := 0;

     LbRouge.Caption := IntToStr(UpDownR.Position) + ' % de Rouge';
     LbVert.Caption := IntToStr(UpDownV.Position) + ' % de Vert';
     LbBleu.Caption := IntToStr(UpDownB.Position) + ' % de Bleu';

     ImgPreview.Invalidate;
end;

procedure TFrmAjuste.BitBtnOkClick(Sender: TObject);
{Objectif :Avertir la fentre PlancheADessin que le bitmap doit tre
           modifier selon le choix de l'utilisateur.
           Destruciton du Bitmap temporaire.}
begin
     If MessageBox( 0, Pchar( 'Ce changement est irrversible alors' +
                              ' dsirez-vous quand mme l''effectuer ? '),
                               'Acceptation ?', MB_YESNO Or MB_ICONQUESTION ) = idYes Then
     Begin
          FrmAjuste.ModalResult := mrOK;
          BitmapTemporaire.Detruire;
     End
     Else
         Exit;
end;


procedure TFrmAjuste.UpDownRClick(Sender: TObject; Button: TUDBtnType);
{Objectif :Afficher le nombre de pourcentage  ajouter ou soustraire de
           chaque couleur}
begin
     LbRouge.Caption := IntToStr(UpDownR.Position) + ' % de Rouge';
     LbVert.Caption := IntToStr(UpDownV.Position) + ' % de Vert';
     LbBleu.Caption := IntToStr(UpDownB.Position) + ' % de Bleu';
end;

end.
