unit Unit5;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, StdCtrls, ComCtrls, ExtCtrls, CLbmp;

type
  TFrmGriser = class(TForm)
    GrBxImage: TGroupBox;
    ImgGrisPreview: TImage;
    GrBxGris: TGroupBox;
    lbIntensite: TLabel;
    UpDownG: TUpDown;
    btVoir: TButton;
    BitBtnAnnuler: TBitBtn;
    BitBtnOk: TBitBtn;
    procedure FormActivate(Sender: TObject);
    procedure btVoirClick(Sender: TObject);
    procedure BitBtnOkClick(Sender: TObject);
    procedure UpDownGClick(Sender: TObject; Button: TUDBtnType);
  public
    { Pourcentage rajout aux couleurs }
     G   :Byte;
  end;

var
  FrmGriser: TFrmGriser;      {Fentre FrmGriser}
  BitmapTemp :TFichierBitmap; {Bitmap temporaire pour prvualisation}
implementation

uses Unit1;

{$R *.DFM}

procedure TFrmGriser.FormActivate(Sender: TObject);
{Objectif : l'activation de cette fentre, crer un bitmap temporaire pour
          les modifications et l'afficher comme preview.}
Begin
     G := 0;

     BitmapTemp := TFichierBitmap.Creer;
     BitMapTemp.CopyBitmapClass( FrmPrincipal.BmpFichier );

     If Not BitmapTemp.DessinerSur( ImgGrisPreview.Canvas.Handle,
                                    ImgGrisPreview.Width,
                                    ImgGrisPreview.Height ) Then
        MessageBox( 0, 'Erreur  l''affichage du Bitmap comme preview.',
                    'Erreur d''Affichage', MB_OK );

     ImgGrisPreview.Invalidate;

     UpDownG.Position := 0;
     LbIntensite.Caption := '0 % d''Intensit';
end;

procedure TFrmGriser.btVoirClick(Sender: TObject);
{Objectif :Dessiner l'image selon le choix de l'utilisateur.}
begin
     BitmapTemp.Griser( UpDownG.Position );

     If Not BitmapTemp.DessinerSur( ImgGrisPreview.Canvas.Handle,
                                    ImgGrisPreview.Width,
                                    ImgGrisPreview.Height ) Then
        MessageBox( 0, 'Erreur  l''affichage du Bitmap en preview.',
                    'Erreur d''Affichage', MB_OK );

     G := G + UpDownG.Position;
     
     UpDownG.Position := 0;
     LbIntensite.Caption := IntToStr(UpDownG.Position) + ' % d''intensit';

     ImgGrisPreview.Invalidate;
end;

procedure TFrmGriser.BitBtnOkClick(Sender: TObject);
{Objectif :Avertir la fentre PlancheADessin que le bitmap doit tre
           modifier selon le choix de l'utilisateur.
           Destruciton du Bitmap temporaire.}
begin
     If MessageBox( 0, Pchar( 'Ce changement est irrversible alors' +
                              ' dsirez-vous quand mme l''effectuer ? '),
                               'Acceptation ?', MB_YESNO Or MB_ICONQUESTION ) = idYes Then
     Begin
          G := G + UpDownG.Position;
          FrmGriser.ModalResult := mrOK;
          BitmapTemp.Detruire;
     End
     Else
         Exit;
end;

procedure TFrmGriser.UpDownGClick(Sender: TObject; Button: TUDBtnType);
{Objectif :Afficher le pourcentage d'intensit}
begin
     LbIntensite.Caption := IntToStr(UpDownG.Position) + ' % d''intensit';
end;

end.
 